function IMatrix = Indicator_Cal(MaxPop,Zmin)

    PopObj               = MaxPop.objs;
    [Num,~]              = size(PopObj);
    Cons                 = max(0,MaxPop.cons);
    NormCons             = Cons./repmat(max(1,max(Cons,[],1)),Num,1);

    CV                   = sum(NormCons,2);

    % shift the objective space to R+
    PopObj               = PopObj - repmat(Zmin,Num,1) + 1e-6;

    % calculate the indicator matrix
    IMatrix              = ones(Num,Num);
    for i = 1:1:Num
        Ci               = CV(i);    
        if Ci == 0 %%%%% Xi is feasible
            Fi               = PopObj(i,:);
            Ir               = log(repmat(Fi,Num,1)./PopObj);
            MaxIr            = max(Ir,[],2);
            MinIr            = min(Ir,[],2);
            CVA              = MaxIr;
            DomInds          = find(MaxIr<=0);
            CVA(DomInds)     = MinIr(DomInds);
            IndicatorV       = CVA;
        else  %%%%% Xi is an infeasible solution
            IC               = repmat(Ci+1e-6,Num,1)./(CV+1e-6); 
            Fi = PopObj(i,:);
            MaxF = max(repmat(Fi,Num,1),PopObj);
            MinF = min(repmat(Fi,Num,1),PopObj);
            CVF = max(MaxF./MinF,[],2);
            IndicatorV       = log(max([CVF,IC],[],2));
        end
        IMatrix(:,i)     = IndicatorV;
        IMatrix(i,i)     = Inf;
    end
end